#[doc = "Register `CONTROL` reader"]
pub struct R(crate::R<CONTROL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CONTROL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CONTROL_SPEC>> for R {
    fn from(reader: crate::R<CONTROL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CONTROL` writer"]
pub struct W(crate::W<CONTROL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CONTROL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CONTROL_SPEC>> for W {
    fn from(writer: crate::W<CONTROL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `MSG_AV_RTRSENT` writer - Msg Available/RTR Sent?If RTReply flag is set, this bit shows if an RTR auto-reply message has been sent, otherwise it indicates if the buffer contains a valid message.?Read: ?'0': Idle?'1': New message available (RTRreply=0), RTR auto-reply message sent (RTRreply=1).??Write:?'0': Idle?'1': Acknowledges receipt of new message or transmission of RTR auto-reply message."]
pub struct MSG_AV_RTRSENT_W<'a> {
    w: &'a mut W,
}
impl<'a> MSG_AV_RTRSENT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "Field `RTR_REPLY_PEND` reader - RTReply_pending status?'0': No RTR reply request pending?'1': RTR reply request pending"]
pub struct RTR_REPLY_PEND_R(crate::FieldReader<bool, bool>);
impl RTR_REPLY_PEND_R {
    pub(crate) fn new(bits: bool) -> Self {
        RTR_REPLY_PEND_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for RTR_REPLY_PEND_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `RTR_ABORT` reader - RTR Abort Request?'0': Idle?'1': Requests removal of a pending RTR message?reply. The flag is cleared when the message?was removed or when the message won arbitration.?The TxReq flag is released at the?same time."]
pub struct RTR_ABORT_R(crate::FieldReader<bool, bool>);
impl RTR_ABORT_R {
    pub(crate) fn new(bits: bool) -> Self {
        RTR_ABORT_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for RTR_ABORT_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `RTR_ABORT` writer - RTR Abort Request?'0': Idle?'1': Requests removal of a pending RTR message?reply. The flag is cleared when the message?was removed or when the message won arbitration.?The TxReq flag is released at the?same time."]
pub struct RTR_ABORT_W<'a> {
    w: &'a mut W,
}
impl<'a> RTR_ABORT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u32 & 0x01) << 2);
        self.w
    }
}
#[doc = "Field `BUFFER_EN` reader - Buffer Enable??0?: Buffer is disabled??1?: Buffer is enabled"]
pub struct BUFFER_EN_R(crate::FieldReader<bool, bool>);
impl BUFFER_EN_R {
    pub(crate) fn new(bits: bool) -> Self {
        BUFFER_EN_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for BUFFER_EN_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `BUFFER_EN` writer - Buffer Enable??0?: Buffer is disabled??1?: Buffer is enabled"]
pub struct BUFFER_EN_W<'a> {
    w: &'a mut W,
}
impl<'a> BUFFER_EN_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | ((value as u32 & 0x01) << 3);
        self.w
    }
}
#[doc = "Field `RTR_REPLY` reader - automatic message reply upon receipt?of an RTR message??0?: Automatic RTR message handling disabled??1?: Automatic RTR message handling enabled??when this bit is set, only RTR message can be received, by setting AMR.RTR=0, AMR.RTR=1.?Otherwise, the RTR reply message content will corrupted by received non-RTR message."]
pub struct RTR_REPLY_R(crate::FieldReader<bool, bool>);
impl RTR_REPLY_R {
    pub(crate) fn new(bits: bool) -> Self {
        RTR_REPLY_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for RTR_REPLY_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `RTR_REPLY` writer - automatic message reply upon receipt?of an RTR message??0?: Automatic RTR message handling disabled??1?: Automatic RTR message handling enabled??when this bit is set, only RTR message can be received, by setting AMR.RTR=0, AMR.RTR=1.?Otherwise, the RTR reply message content will corrupted by received non-RTR message."]
pub struct RTR_REPLY_W<'a> {
    w: &'a mut W,
}
impl<'a> RTR_REPLY_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | ((value as u32 & 0x01) << 4);
        self.w
    }
}
#[doc = "Field `RX_INT_EBL` reader - RxIntEbl, Receive Interrupt Enable??0?: Interrupt generation is disabled?'1?: Interrupt generation is enabled"]
pub struct RX_INT_EBL_R(crate::FieldReader<bool, bool>);
impl RX_INT_EBL_R {
    pub(crate) fn new(bits: bool) -> Self {
        RX_INT_EBL_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for RX_INT_EBL_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `RX_INT_EBL` writer - RxIntEbl, Receive Interrupt Enable??0?: Interrupt generation is disabled?'1?: Interrupt generation is enabled"]
pub struct RX_INT_EBL_W<'a> {
    w: &'a mut W,
}
impl<'a> RX_INT_EBL_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | ((value as u32 & 0x01) << 5);
        self.w
    }
}
#[doc = "Field `LINK_FLAG` reader - Link Flag??0?: This buffer is not linked to the next??1?: This buffer is linked with next buffer"]
pub struct LINK_FLAG_R(crate::FieldReader<bool, bool>);
impl LINK_FLAG_R {
    pub(crate) fn new(bits: bool) -> Self {
        LINK_FLAG_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for LINK_FLAG_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `LINK_FLAG` writer - Link Flag??0?: This buffer is not linked to the next??1?: This buffer is linked with next buffer"]
pub struct LINK_FLAG_W<'a> {
    w: &'a mut W,
}
impl<'a> LINK_FLAG_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | ((value as u32 & 0x01) << 6);
        self.w
    }
}
#[doc = "Field `WPNL` reader - WPNL, Write Protectiontion for bit \\[6:3\\].?'0': Bits \\[6:3\\]
are write protected,?'1': Bits \\[6:3\\]
are modified by writes.?This WPNL bit must always be set in the same write that is modifying bits \\[6:3\\], as this bit state is not preserved.?This bit is always zero for readback."]
pub struct WPNL_R(crate::FieldReader<bool, bool>);
impl WPNL_R {
    pub(crate) fn new(bits: bool) -> Self {
        WPNL_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for WPNL_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `WPNL` writer - WPNL, Write Protectiontion for bit \\[6:3\\].?'0': Bits \\[6:3\\]
are write protected,?'1': Bits \\[6:3\\]
are modified by writes.?This WPNL bit must always be set in the same write that is modifying bits \\[6:3\\], as this bit state is not preserved.?This bit is always zero for readback."]
pub struct WPNL_W<'a> {
    w: &'a mut W,
}
impl<'a> WPNL_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | ((value as u32 & 0x01) << 7);
        self.w
    }
}
#[doc = "Field `DLC` reader - DLC, Data Length Code?0: Message has 0 data bytes, data\\[63:0\\]
is notvalid?1: Message has 1 data byte, data\\[63:56\\]
is valid?..?8: Message has 8 data bytes, data\\[63:0\\]
is valid?9-15: Message has 8 data bytes??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct DLC_R(crate::FieldReader<u8, u8>);
impl DLC_R {
    pub(crate) fn new(bits: u8) -> Self {
        DLC_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DLC_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DLC` writer - DLC, Data Length Code?0: Message has 0 data bytes, data\\[63:0\\]
is notvalid?1: Message has 1 data byte, data\\[63:56\\]
is valid?..?8: Message has 8 data bytes, data\\[63:0\\]
is valid?9-15: Message has 8 data bytes??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct DLC_W<'a> {
    w: &'a mut W,
}
impl<'a> DLC_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 16)) | ((value as u32 & 0x0f) << 16);
        self.w
    }
}
#[doc = "Field `IDE_FMT` reader - Extended Identifier Bit?'1': This is an extended format message?'0': This is a standard format message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct IDE_FMT_R(crate::FieldReader<bool, bool>);
impl IDE_FMT_R {
    pub(crate) fn new(bits: bool) -> Self {
        IDE_FMT_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for IDE_FMT_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `IDE_FMT` writer - Extended Identifier Bit?'1': This is an extended format message?'0': This is a standard format message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct IDE_FMT_W<'a> {
    w: &'a mut W,
}
impl<'a> IDE_FMT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | ((value as u32 & 0x01) << 20);
        self.w
    }
}
#[doc = "Field `RTR_MSG` reader - Remote Bit?'1': This is an RTR message?'0': This is a regular message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be set to 0 (data frame type) by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct RTR_MSG_R(crate::FieldReader<bool, bool>);
impl RTR_MSG_R {
    pub(crate) fn new(bits: bool) -> Self {
        RTR_MSG_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for RTR_MSG_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `RTR_MSG` writer - Remote Bit?'1': This is an RTR message?'0': This is a regular message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be set to 0 (data frame type) by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
pub struct RTR_MSG_W<'a> {
    w: &'a mut W,
}
impl<'a> RTR_MSG_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | ((value as u32 & 0x01) << 21);
        self.w
    }
}
#[doc = "Field `WPNH` reader - WPNH, Write Protection for bits\\[21:16\\].?'0': Bit \\[21:16\\]
are write protected,?'1': Bit \\[21:16\\]
are modified by writes.?The WPNH bit must always be set in the same write that is modifying the bits\\[21:16\\]
as this bit state is not preserved.?The readback value of this bit is undefined."]
pub struct WPNH_R(crate::FieldReader<bool, bool>);
impl WPNH_R {
    pub(crate) fn new(bits: bool) -> Self {
        WPNH_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for WPNH_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `WPNH` writer - WPNH, Write Protection for bits\\[21:16\\].?'0': Bit \\[21:16\\]
are write protected,?'1': Bit \\[21:16\\]
are modified by writes.?The WPNH bit must always be set in the same write that is modifying the bits\\[21:16\\]
as this bit state is not preserved.?The readback value of this bit is undefined."]
pub struct WPNH_W<'a> {
    w: &'a mut W,
}
impl<'a> WPNH_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | ((value as u32 & 0x01) << 23);
        self.w
    }
}
impl R {
    #[doc = "Bit 1 - RTReply_pending status?'0': No RTR reply request pending?'1': RTR reply request pending"]
    #[inline(always)]
    pub fn rtr_reply_pend(&self) -> RTR_REPLY_PEND_R {
        RTR_REPLY_PEND_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - RTR Abort Request?'0': Idle?'1': Requests removal of a pending RTR message?reply. The flag is cleared when the message?was removed or when the message won arbitration.?The TxReq flag is released at the?same time."]
    #[inline(always)]
    pub fn rtr_abort(&self) -> RTR_ABORT_R {
        RTR_ABORT_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Buffer Enable??0?: Buffer is disabled??1?: Buffer is enabled"]
    #[inline(always)]
    pub fn buffer_en(&self) -> BUFFER_EN_R {
        BUFFER_EN_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - automatic message reply upon receipt?of an RTR message??0?: Automatic RTR message handling disabled??1?: Automatic RTR message handling enabled??when this bit is set, only RTR message can be received, by setting AMR.RTR=0, AMR.RTR=1.?Otherwise, the RTR reply message content will corrupted by received non-RTR message."]
    #[inline(always)]
    pub fn rtr_reply(&self) -> RTR_REPLY_R {
        RTR_REPLY_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - RxIntEbl, Receive Interrupt Enable??0?: Interrupt generation is disabled?'1?: Interrupt generation is enabled"]
    #[inline(always)]
    pub fn rx_int_ebl(&self) -> RX_INT_EBL_R {
        RX_INT_EBL_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Link Flag??0?: This buffer is not linked to the next??1?: This buffer is linked with next buffer"]
    #[inline(always)]
    pub fn link_flag(&self) -> LINK_FLAG_R {
        LINK_FLAG_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - WPNL, Write Protectiontion for bit \\[6:3\\].?'0': Bits \\[6:3\\]
are write protected,?'1': Bits \\[6:3\\]
are modified by writes.?This WPNL bit must always be set in the same write that is modifying bits \\[6:3\\], as this bit state is not preserved.?This bit is always zero for readback."]
    #[inline(always)]
    pub fn wpnl(&self) -> WPNL_R {
        WPNL_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bits 16:19 - DLC, Data Length Code?0: Message has 0 data bytes, data\\[63:0\\]
is notvalid?1: Message has 1 data byte, data\\[63:56\\]
is valid?..?8: Message has 8 data bytes, data\\[63:0\\]
is valid?9-15: Message has 8 data bytes??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn dlc(&self) -> DLC_R {
        DLC_R::new(((self.bits >> 16) & 0x0f) as u8)
    }
    #[doc = "Bit 20 - Extended Identifier Bit?'1': This is an extended format message?'0': This is a standard format message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn ide_fmt(&self) -> IDE_FMT_R {
        IDE_FMT_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Remote Bit?'1': This is an RTR message?'0': This is a regular message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be set to 0 (data frame type) by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn rtr_msg(&self) -> RTR_MSG_R {
        RTR_MSG_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 23 - WPNH, Write Protection for bits\\[21:16\\].?'0': Bit \\[21:16\\]
are write protected,?'1': Bit \\[21:16\\]
are modified by writes.?The WPNH bit must always be set in the same write that is modifying the bits\\[21:16\\]
as this bit state is not preserved.?The readback value of this bit is undefined."]
    #[inline(always)]
    pub fn wpnh(&self) -> WPNH_R {
        WPNH_R::new(((self.bits >> 23) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Msg Available/RTR Sent?If RTReply flag is set, this bit shows if an RTR auto-reply message has been sent, otherwise it indicates if the buffer contains a valid message.?Read: ?'0': Idle?'1': New message available (RTRreply=0), RTR auto-reply message sent (RTRreply=1).??Write:?'0': Idle?'1': Acknowledges receipt of new message or transmission of RTR auto-reply message."]
    #[inline(always)]
    pub fn msg_av_rtrsent(&mut self) -> MSG_AV_RTRSENT_W {
        MSG_AV_RTRSENT_W { w: self }
    }
    #[doc = "Bit 2 - RTR Abort Request?'0': Idle?'1': Requests removal of a pending RTR message?reply. The flag is cleared when the message?was removed or when the message won arbitration.?The TxReq flag is released at the?same time."]
    #[inline(always)]
    pub fn rtr_abort(&mut self) -> RTR_ABORT_W {
        RTR_ABORT_W { w: self }
    }
    #[doc = "Bit 3 - Buffer Enable??0?: Buffer is disabled??1?: Buffer is enabled"]
    #[inline(always)]
    pub fn buffer_en(&mut self) -> BUFFER_EN_W {
        BUFFER_EN_W { w: self }
    }
    #[doc = "Bit 4 - automatic message reply upon receipt?of an RTR message??0?: Automatic RTR message handling disabled??1?: Automatic RTR message handling enabled??when this bit is set, only RTR message can be received, by setting AMR.RTR=0, AMR.RTR=1.?Otherwise, the RTR reply message content will corrupted by received non-RTR message."]
    #[inline(always)]
    pub fn rtr_reply(&mut self) -> RTR_REPLY_W {
        RTR_REPLY_W { w: self }
    }
    #[doc = "Bit 5 - RxIntEbl, Receive Interrupt Enable??0?: Interrupt generation is disabled?'1?: Interrupt generation is enabled"]
    #[inline(always)]
    pub fn rx_int_ebl(&mut self) -> RX_INT_EBL_W {
        RX_INT_EBL_W { w: self }
    }
    #[doc = "Bit 6 - Link Flag??0?: This buffer is not linked to the next??1?: This buffer is linked with next buffer"]
    #[inline(always)]
    pub fn link_flag(&mut self) -> LINK_FLAG_W {
        LINK_FLAG_W { w: self }
    }
    #[doc = "Bit 7 - WPNL, Write Protectiontion for bit \\[6:3\\].?'0': Bits \\[6:3\\]
are write protected,?'1': Bits \\[6:3\\]
are modified by writes.?This WPNL bit must always be set in the same write that is modifying bits \\[6:3\\], as this bit state is not preserved.?This bit is always zero for readback."]
    #[inline(always)]
    pub fn wpnl(&mut self) -> WPNL_W {
        WPNL_W { w: self }
    }
    #[doc = "Bits 16:19 - DLC, Data Length Code?0: Message has 0 data bytes, data\\[63:0\\]
is notvalid?1: Message has 1 data byte, data\\[63:56\\]
is valid?..?8: Message has 8 data bytes, data\\[63:0\\]
is valid?9-15: Message has 8 data bytes??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn dlc(&mut self) -> DLC_W {
        DLC_W { w: self }
    }
    #[doc = "Bit 20 - Extended Identifier Bit?'1': This is an extended format message?'0': This is a standard format message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be aligned offline and set by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn ide_fmt(&mut self) -> IDE_FMT_W {
        IDE_FMT_W { w: self }
    }
    #[doc = "Bit 21 - Remote Bit?'1': This is an RTR message?'0': This is a regular message??depending on RTR_REPLY setting,?0, this field will be updated by received data/remote frame?1, this field should be set to 0 (data frame type) by user in advance, will not be updated by received data/remote frame, and will be sent out in responsive data frame"]
    #[inline(always)]
    pub fn rtr_msg(&mut self) -> RTR_MSG_W {
        RTR_MSG_W { w: self }
    }
    #[doc = "Bit 23 - WPNH, Write Protection for bits\\[21:16\\].?'0': Bit \\[21:16\\]
are write protected,?'1': Bit \\[21:16\\]
are modified by writes.?The WPNH bit must always be set in the same write that is modifying the bits\\[21:16\\]
as this bit state is not preserved.?The readback value of this bit is undefined."]
    #[inline(always)]
    pub fn wpnh(&mut self) -> WPNH_W {
        WPNH_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RxMessage Buffer control/command\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [control](index.html) module"]
pub struct CONTROL_SPEC;
impl crate::RegisterSpec for CONTROL_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [control::R](R) reader structure"]
impl crate::Readable for CONTROL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [control::W](W) writer structure"]
impl crate::Writable for CONTROL_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CONTROL to value 0"]
impl crate::Resettable for CONTROL_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
